# PRG - Exam Test #

This is the assignment for the PRG exam test. Follow the instructions precisely and do not add
any additional code to the modules implemented (not even print statements) as they will be imported
and evaluated automatically. Syntactic errors in a module result in 0 points from the assignment,
as all automatic tests will fail on that module.

The modules (packages) you implement should be packed in a zip file (files should be in the root of
the zip file, zipping directly the files, not the containing folder) and uploaded to BRUTE. For
every module, class and function you implement, do not forget to add a docstring. Code quality
(mainly following naming conventions and writing docstrings) is part of the grading of your
solution.


## Task 1 [2p] ##

Create a module named "list_equality". In this module, implement two functions: shallow_eq and
deep_eq. Both functions take two arguments, lists, and return whether the lists are equal. In case
of shallow_eq, shallow equality is tested; in deep_eq function, deep equality is tested. In the
function docstrings, explain both concepts and comment on their difference.


## Task 2 [6p] ##

Create a module named "task2_functions" and implement three functions according to the following
unit tests. You can put the unit tests (from below) to the same module.

```
import unittest

class TestFunctions(unittest.TestCase):

    def test_set_element_by_index(self):
        # [2.5p]
        self.assertEqual((1, 'a', 3, 4), set_element_by_index((1, 2, 3, 4), 1, 'a'))
        self.assertEqual(('z', 'b'), set_element_by_index(('a', 'b'), 0, 'z'))
        self.assertEqual((1, 2.0, 'c', False), set_element_by_index((1, 2.0, 'c', True), 3, False))
        with self.assertRaises(IndexError):
            set_element_by_index((1, 2), 3, True)

    def test_remove_vowels(self):
        # [1.5p]
        self.assertEqual("Sttng ndr tr", remove_vowels("Sitting under tree"))
        self.assertEqual(" r nc!", remove_vowels("You are nice!"))
        self.assertEqual("Zzz. Psst!", remove_vowels("Zzz. Psst!"))

    def test_common_list_elements(self):
        # [2p]
        self.assertEqual([2, 3], common_list_elements([1, 2, 3], [2, 3, 4]))
        self.assertEqual(['d'], common_list_elements(['a', 'd', 0], [0.1, 'd', 1, 'b']))
        self.assertEqual([], common_list_elements([1, 2, 3, 4], ['a', 'b', 'c', 'd']))
```


## Task 3 [6p] ##

Create a module named "dict_io", which will contain two functions. These two function will save and
load a dict of integers in a text file. In this dictionary, both keys and values are integers. The
format of the file is up to you, only make sure that the load function can load what the save
function has saved.

1. [2.5p] Implement function save_dict, which takes two arguments - a dict of integers and a file
    path, and will store the dict under given path.
2. [1p] In function save_dict, if the file under given path already exists, save the data under
    a different path, prepending 'new_' to the base of the file name (i.e. '/foo/bar/file.txt' ->
    '/foo/bar/new_file.txt'). You do not need to check whether the new path exists.
3. [2.5p] Implement function load_dict, which takes a single argument, a file path, and returns
    a dict loaded. If the file does not exist, return an empty dict.


## Task 4 [5p] ##

Create a package containing a single module. In this module, implement a function operating on
strings.

1. [1p] Choose the name of the package, module and function appropriately based on the
    functionality defined below.
2. [2p] Implement a function that takes two arguments, string containing multiple sentences
    separated by a period (".") and a query word, and returns the first sentence containing the
    word (e.g. 'Hello. My name is Emanuel. Nice to meet you.' & 'meet' -> 'Nice to meet you.').
3. [2p] On the same level as the package (top-level folder), create a module containing unit tests
    for the implemented module. Make sure that the tests pass for your functions.


## Task 5 [6p] ##

Create a module named "words".

1. [1p] Implement class Phrase that stores phrase (string) consisting of words.
2. [2p] Implement support for the plus operator, where the first argument is always Phrase
    instance and second argument can be either string or also Phrase instance. The result of
    the addition is a new Phrase instance.
3. [1p] Implement the equality operator - two Phrase instances are equal if and only if the
    sequences of words are the same. Case of the words and extra spaces do not matter.
4. [2p] Implement a class SingleWordPhrase that inherits from Phrase and which phrase contains
    a single word. Ensure this by raising an appropriate exception. Try to reuse as much code from
    Phrase class as possible.

Phrase example:

```
>>> Phrase("Studying hard") == Phrase("  studying    hard  ")
True
>>> Phrase("Preparing for the exam") == Phrase("") + "Preparing" + Phrase("For the") + "EXAM"
True
```


## Epilogue ##

At the end of the test, the following files (folders) should be present in your zip file. They
should be in the root of the zip file, not in a nested folder.

- [folder of chosen name] - task 4
- dict_io.py - task 3
- list_equality.py - task 1
- task2_functions.py - task 2
- test_[module of chosen name].py - task 4
- words.py - task 5

